// Ubiquity provides a standards-based suite of browser enhancements for
// building a new generation of internet-related applications.
//
// The Ubiquity SMIL module adds SMIL support to the Ubiquity library.
//
// Copyright (C) 2008 Backplane Ltd.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**@fileoverview 
	Contains the definitions used to set up the decorator for SMIL.
*/

/**@requires
	decorate.js
*/

// Add XForms decoration rules
DECORATOR.addDecorationRules({
    "namespaceURI" : "http://www.example.com/namespaces/blink",
    "rules" : {
		"blink" : [
		{
			"name" : "blink-element",
			"apply" : function(arrBehaviours) {
				return arrBehaviours.concat([BlinkBlink]);
			}
		}
		]
	}
});

NamespaceManager.addSelectionNamespace("blink", "http://www.example.com/namespaces/blink");	

DECORATOR.setupDecorator(
	[
		{
			selector: "blink|blink",
			objects: [  ]
		},

	],
	"http://www.example.com/namespaces/blink"
);
