// Ubiquity provides a standards-based suite of browser enhancements for
// building a new generation of internet-related applications.
//
// The Ubiquity SMIL module adds SMIL support to the Ubiquity library.
//
// Copyright (C) 2008 Backplane Ltd.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview 
 * Module dependencies for SMIL Language Profile.
 */
 
/*global loader, pathToModule*/

(
  function(){
    var moduleBase = pathToModule("smil-language-loader");

    loader.addModule({ name: "smil-structure",  type: "js", fullpath: moduleBase + "smil-structure.js" });
    loader.addModule({ name: "smil-sched",  type: "js", fullpath: moduleBase + "../scheduler/smil-sched.js" });
    loader.addModule({ name: "smil-playable",  type: "js", fullpath: moduleBase + "../playables/smil-playable.js" });
    loader.addModule({ name: "smil-layout",  type: "js", fullpath: moduleBase + "smil-layout.js" });

    loader.addModule({ name: "smil-language-defs",        type: "js", fullpath: moduleBase + "smil-language-defs.js",
      requires: [ "libxh-decorator", "smil-sched", "smil-playable", "smil-layout", "smil-structure" ] });

    loader.require( "smil-language-defs" );
    loader.require( "xforms-defs" );
    
    loader.require( "second-onload" );
  }()
);
