/**@fileoverview 
	SMIL Structure implementation.
*/


/**
 * &lt;smil:smil&gt; element implementation. 
 * Currently a placeholder only.
 * @constructor
 * @param {DOMElement} elmnt The DOM element.
*/
function SmilSmil(elmnt)
{
	this.elmnt = elmnt;
}

/**
 * &lt;smil:body&gt; element implementation. 
 * Starts playback of the document, after a small timeout.
 * @constructor
 * @param {DOMElement} elmnt The DOM element.
*/
function SmilBody(elmnt)
{
	this.elmnt = elmnt;
	if (elmnt) {
		elmnt.smil_body_object = this;
	}
	var that = this;
	
	window.setTimeout(function() { that.startDocument(); }, 100);
}

/**
 * Start playback, by calling our own smilPlayable_start method.
 */
SmilBody.prototype.startDocument = function ()
{
	this.elmnt.ownerDocument.logger.log("jsambulant: startDocument");
	if (this.elmnt.smil_playable_object === undefined) {
		this.elmnt.ownerDocument.logger.log("jsambulant: startDocument called on non-SMIL element");
		this.playdone_document(this.elmnt);
		return;
	}
	this.elmnt.smil_playable_object.smilPlayable_start(this.playdone_document);
};

/**
 * Calback method, called on completion of document playback.
 * @param {DOMElement} element HTML element, should be this.elmnt.
 */
SmilBody.prototype.playdone_document = function (elmnt)
{
	this.elmnt.smil_playable_object.smilPlayable_stop();
	elmnt.ownerDocument.logger.log("jsambulant: playdone_document");
};

