/**
 * @fileoverview 
 * Main starting point for embedding SMIL in (X)HTML.
 */
var UX = { };


function pathToModule(module) { 
  if (!module) {
    throw("Missing or null parameter supplied.");
  }
  var childNodes = document.childNodes; 
  var l = childNodes.length;
  var i;
  var head;
  for (i = 0; i < l; ++i) {
    if(childNodes[i].nodeName.toLowerCase() === "html") {
      head = childNodes[i].firstChild;
    }
  }
  
  childNodes = head.childNodes;
  l = childNodes.length;
  var s = null;
  var el, src, pos;

  for (i = 0; i < l; ++i) {
    el = childNodes[i];
    if (el.nodeType === 1 && el.nodeName === "SCRIPT") {
      src = el.src;
      if (src) {
        pos = src.lastIndexOf(module + ".js");
        
        if (pos != -1 && (!pos || src.charAt(pos - 1) === "/" || src.charAt(pos - 1) === "\\")) {
          s = src.slice(0, pos);
          break;
        }
      }// if @src is present
    }// if we have a script element
  }// for each child node

  if (!s) {
    throw("No Module called '" + module + "' was found.");
  }
  return s;
}

//g_ubiquityDirectory = "http://ubiquity-xforms.googlecode.com/svn/tags/0.6.1/";
//g_ubiquityDirectory = "../../../../../packages/ubiquity-xforms-read-only/src/";
/*global g_ubiquityDirectory*/
g_ubiquityDirectory = "ubiquity-xforms/";
/*global g_sBehaviourDirectory*/
g_sBehaviourDirectory = g_ubiquityDirectory + "behaviours/";

(

  function()
  {
    var baseDefaultPath = pathToModule("ubiquity-loader");
    g_ubiquityDirectory = baseDefaultPath + "../../thirdparty/ubiquity-xforms/";
    g_sBehaviourDirectory = g_ubiquityDirectory + "behaviours/";
    var arrScripts = [
    	  "http://yui.yahooapis.com/2.5.2/build/yuiloader/yuiloader-beta-min.js",
	      g_ubiquityDirectory + "lib/sniffer.js",
    	  g_ubiquityDirectory + "lib/xforms/ie-instance-fixer.js",
      	  g_ubiquityDirectory + "lib/xforms/ie6-css-selectors-fixer.js",
    	  g_ubiquityDirectory + "lib/xforms/set-document-loaded.js",
//    	  g_ubiquityDirectory + "lib/xforms/xforms-threads.js",
    	  g_ubiquityDirectory + "lib/threads.js",
    	  g_ubiquityDirectory + "lib/xforms/loader-begin.js",
    	  g_ubiquityDirectory + "lib/xforms/xforms-loader.js",
    	  baseDefaultPath + "smil-language-loader.js",
          g_ubiquityDirectory + "lib/xforms/loader-end.js"
    ];

    var arrScriptElements = [ ];
    var i, l = arrScripts.length;
    for (i = 0 ; i < l ; ++i) {
      arrScriptElements.push('<script src="' + arrScripts[i] +'" type="text/javascript">/**/</script>');
    }
    
    document.write(arrScriptElements.join("\n"));
  }()
);
